#include "libraries.h"
#include "functions.h"
#include "TopSecret.h"

SimpleTimer timer;

void setup()
{
  Serial.begin(115200);
  delay(500); // Delay to let the ESP get booted before sending out serial data
  Serial.printf("\n+---------------------------------------+\n");
  Serial.printf("|  ESP With a little OLED & 2 DS18B20s  |\n");
  Serial.printf("|  WiFi Enabled...                      |\n");
  Serial.printf("|  Sends readings out through MQTT...   |\n");
  // Serial.printf("|  Should be able to respond to MQTT... |\n");
  // Serial.printf("+---------------------------------------+\n");

  WiFi_init();

  MQTT_init();

  // SSD1306 ///////////////////////////////////////////////////////////////////

  SSD1306_init();

  // Display static text
  SSD1306_title("ColdStuff");
  SSD1306_Static("Beer:", 1);
  SSD1306_Static("Food:", 2);

  Serial.printf("| Static Text on-screen                 |\n");

  // DS18B20 ///////////////////////////////////////////////////////////////////

  DS18B20_init();

  Serial.printf("+---------------------------------------+\n");
  // timer.setInterval(20, SSD1306_Dotty);
  timer.setInterval(20, DOtheBloodyMQTT);
  // delay(66);
  timer.setInterval(20, SSD1306_DisplayTemps);

  Serial.printf("| Interval Timers running               |\n");
  Serial.printf("+---------------------------------------+\n");
}

void loop()
{
  timer.run();
}
